=== debian/changelog ===
utopia-documents (2.4.4-2) unstable; urgency=medium

  * Updated copyright file to include additional licenses.
  * Fixed path specifications in copyright file.
  * Reordered build-depends alternatives to satisfy build servers.
  * Added remove_incorrect_copyright_headers.diff to remove incorrectly applied
    copyright headers.
  * Added remove_unused_timeoutsocket.diff to remove unused python module that
    used a BSD advertising clause license.
  * Added remove_xpdf_vms_files.diff to remove unused VMS code that used a
    BSD advertising clause license.
  * Patches accepted upstream.
  * Re-upload to Debian proper (Closes: #760487)
  
 -- James Marsh <debian@jamesmarsh.net>  Tue, 21 Oct 2014 18:57:45 +0100

utopia-documents (2.4.4-1) neurodebian; urgency=medium

  * New upstream release.
  * Initial upload to Debian proper - REJECTED.
  
 -- James Marsh <debian@jamesmarsh.net>  Thu, 04 Sep 2014 10:25:11 -0400

utopia-documents (2.4.3-1) UNRELEASED; urgency=medium

  * New upstream release.

 -- The Utopia Project <info@utopiadocs.com>  Wed, 27 Aug 2014 12:03:20 +0100
